
/* (c) 2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "defines.h"
#include "ai.h"
#include "../common/parse.h"
#include "../client/network.h"


extern double player_x, player_y;
extern int player_status;


int ai_init(void) {

  return SUCCEEDED;
}


int ai_pass(unsigned char *vision, int dx, int dy, struct game_object *visible_objects) {

  struct game_object *go;
  int i, x, y, id, r, g, b;
  char tmp[5];


  /* identify object id colors (r >= 128) */
  for (i = 0, y = 0; y < dy; y++) {
    for (x = 0; x < dx; x++, i += 4) {
      if ((vision[i + 0] & 128) != 0) {
	r = vision[i + 0] & 127;
	g = vision[i + 1];
	b = vision[i + 2];
	id = (r << 16) | (g << 8) | b;

	go = visible_objects;
	while (go != NULL) {
	  if (go->id == id)
	    break;
	  go = go->next_ext;
	}

	if (go == NULL) {
	  fprintf(stderr, "AI_PASS: Object \"%d\" not found in view frustum!\n", id);
	  continue;
	}

	go->hits++;
      }
    }
  }

  /* list hits */
  go = visible_objects;
  while (go != NULL) {
    if (go->hits > 200) {
      tmp[0] = 'P';
      write_int(tmp + 1, go->id);
      send_data(tmp, 5);
      fprintf(stderr, "AI_PASS: %d pixels of \"%d\" were seen.\n", go->hits, go->id);
    }
    go = go->next_ext;
  }

  /* turn the head */
  player_x += 0.5;
  if (player_x < 0)
    player_x += 360;
  if (player_x >= 360)
    player_x -= 360;
  player_status |= PLAYER_STATUS_MOVED;

  return SUCCEEDED;
}
