
/* (c) 2002-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include <SDL/SDL_video.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "defines.h"
#include "action.h"
#include "network.h"
#include "game_object.h"
#include "move_list.h"
#include "../common/parse.h"


extern struct game_object **game_object_map, *closest_object;
extern struct vector player_source, player_target;
extern int world_x, world_y, world_z, cross_status;

struct inventory_item *inventory = NULL;


void action_pick_up(void) {

  char tmp[8];


  if (cross_status == OFF || closest_object == NULL)
    return;

  tmp[0] = 'P';
  write_int(tmp + 1, closest_object->id);
  send_data(tmp, 5);
}


int action_add_to_inventory(int object) {

  struct inventory_item *i;


  i = malloc(sizeof(struct inventory_item));
  if (i == NULL) {
    fprintf(stderr, "ACTION_ADD_TO_INVENTORY: Out of memory error.\n");
    return FAILED;
  }

  i->object = object;
  i->prev = NULL;
  i->next = inventory;
  if (inventory != NULL)
    inventory->prev = i;
  inventory = i;

  return SUCCEEDED;
}


int action_throw(void) {

  struct game_object *g;
  char tmp[128];
  int i;


  if (game_object_dummy_get(&g) == FAILED) {
    return FAILED;
  }

  g->object = OBJ_ROCK_01;
  g->status = GO_COLLISION;
  g->name[0] = 0;
  g->x = player_source.x;
  g->y = player_source.y;
  g->z = player_source.z;
  g->ax = 0;
  g->ay = 0;
  g->az = 0;

  game_object_add(g, 1);
  move_list_add(&g->mit);

  /* tell the server that we transformed one of our dummy objects into a real object */
  tmp[0] = 'n';
  i = 1;
  write_int_a(tmp, &i, g->id);
  write_int_a(tmp, &i, g->object);
  write_double_a(tmp, &i, g->x);
  write_double_a(tmp, &i, g->y);
  write_double_a(tmp, &i, g->z);
  write_float_a(tmp, &i, g->ax);
  write_float_a(tmp, &i, g->ay);
  write_float_a(tmp, &i, g->az);
  strcpy(tmp + i, g->name);
  i += strlen(g->name) + 1;
  tmp[i++] = g->status;
  send_data(tmp, i);

  return SUCCEEDED;
}
