
/* (c) 2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "hash.h"
#include "defines.h"



int hash_memory(char *m, unsigned int size, unsigned int *hash) {

  unsigned int i, n, k;


  if (m == NULL || size == 0 || hash == NULL)
    return FAILED;

  /* compute the hash of the file */
  i = 0;
  for (k = 0; k < size; k++) {
    n = m[k];
    i = n + (i << 6) + (i << 16) - i;
  }

  *hash = i;

  return SUCCEEDED;
}


int hash_file(char *name, unsigned int *hash) {

  unsigned int n;
  FILE *f;
  char *c;


  if (name == NULL || hash == NULL)
    return FAILED;

  /* read the whole file into memory */
  f = fopen(name, "rb");
  if (f == NULL) {
    fprintf(stderr, "HASH_FILE: Could not open file \"%s\" for reading.\n", name);
    return FAILED;
  }

  fseek(f, 0, SEEK_END);
  n = ftell(f);
  fseek(f, 0, SEEK_SET);

  c = malloc(n);
  if (c == NULL) {
    fprintf(stderr, "HASH_FILE: Out of memory error.\n");
    fclose(f);
    return FAILED;
  }

  fread(c, 1, n, f);
  fclose(f);
  hash_memory(c, n, hash);
  free(c);

  return SUCCEEDED;
}
