
#ifndef DEFINES_H
#define DEFINES_H 0

#include "../common/common.h"

#define ROOM_MIN_DX 3
#define ROOM_MIN_DY 3

#define ROOM_MAX_DX 7
#define ROOM_MAX_DX 7

#define HOUSE_MIN_DX 4
#define HOUSE_MIN_DY 4

#define BLOCK_DX 2.0
#define BLOCK_DY 2.0
#define BLOCK_DZ 4.0

#define NEIGHBOUR_UP 0
#define NEIGHBOUR_DOWN 1
#define NEIGHBOUR_LEFT 2
#define NEIGHBOUR_RIGHT 3

struct neighbour {
  int x, y;
  int neighbour;
  int doored;
  unsigned char room;
  struct neighbour *next;
};

struct house_floor {
  unsigned char *floor_plan, *floor_mask;
  unsigned char *walls_hor, *walls_ver;
  unsigned char area[256];
  unsigned char *ceiling, *floor;
  unsigned char *staircase_base;
  struct neighbour *room_neighbours[256];
  struct house_floor *next;
};

/* description of the map items

   l - wall on the left
   r - wall on the right
   - - wall on the up
   _ - wall on the down

   d - door on the right
   o - opening on the left

   D - door on the up
   O - opening on the down */

#endif
