
/* (c) 2001-2002 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "defines.h"
#include "common.h"
#include "smooth.h"


extern double *map, *map_vertices_z, *map_vertices_xy, *map_normals, *map_triangle_normals;
extern char *map_shadow, *map_area;
extern int size, *map_triangles;


int smooth_run(void) {

  double d, *r;
  int x, y, i;


  r = malloc(sizeof(double) * size * size);
  if (r == NULL) {
    fprintf(stderr, "SMOOTH_RUN: Out of memory error.\n");
    return FAILED;
  }

  for (i = 0, y = 0; y < size; y++) {
    for (x = 0; x < size; x++, i++) {
      d = 0;
      map_read(x + 1, y - 1, &d);
      map_read(x + 1, y + 0, &d);
      map_read(x + 1, y + 1, &d);
      map_read(x - 1, y - 1, &d);
      map_read(x - 1, y + 0, &d);
      map_read(x - 1, y + 1, &d);
      map_read(x + 0, y - 1, &d);
      map_read(x + 0, y + 0, &d);
      map_read(x + 0, y + 1, &d);
      r[i] = d/9.0;
    }
  }

  /* return the result */
  for (x = 0; x < size * size; x++)
    map[x] = r[x];

  free(r);

  return SUCCEEDED;
}


int remove_lonely_area_squares(void) {

  int x, y;
  char c, d;


  for (y = 0; y < size; y++) {
    for (x = 0; x < size; x++) {
      map_area_read(x + 0, y + 0, &c);
      map_area_read(x + 1, y + 0, &d);
      if (c == d)
	continue;
      map_area_read(x - 1, y + 0, &d);
      if (c == d)
	continue;
      map_area_read(x + 0, y + 1, &d);
      if (c == d)
	continue;
      map_area_read(x + 0, y - 1, &d);
      if (c == d)
	continue;
      /* this block is alone! -> remove it */
      map_area[y * size + x] = d;
      printf("REMOVE_LONELY_AREA_SQUARES: %d replaced with %d in (%d, %d).\n", c, d, x, y);
    }
  }

  return SUCCEEDED;
}
